config/routes.rb
Rails.application.routes.draw do
  mount Ckeditor::Engine => '/ckeditor'
  devise_for :users, controllers: {registrations: "registrations"}
  post 'likes/create'
  post 'likes/destroy'
  post 'dislikes/create'
  post 'dislikes/destroy'
  post 'comments/reply'
  post 'comments/approve'
  get 'post/my', to: 'posts#my', as: :my_posts
  get 'posts/index', to: 'posts#index', as: :post_index

  resources :posts do
    resources :comments
    resources :ratings
  end

  resources :admin do
    resources :tags

    root to: "tags#index"
  end

  resources :tags
  resources :users

  root 'posts#index'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  acts_as_tree order: 'created_at DESC'
  belongs_to :user
  belongs_to :post #, dependent: :destroy
  has_many :like, dependent: :destroy
  has_many :dislike, dependent: :destroy

  validates :title, presence: {message: "Missing title"}
  validates :content, presence: {message: "Missing content"}

  before_save :generate_timestamp

  def generate_timestamp
    self.added = DateTime.now
  end

  def likes_count
    self.like.count()
  end

  def can_like id
    self.like.where(user_id: id).empty?
  end

  def dislikes_count
    self.dislike.count()
  end

  def can_dislike id
    self.dislike.where(user_id: id).empty?
  end

end

app/models/dislike.rb
class Dislike < ApplicationRecord
  belongs_to :user
  belongs_to :comment
end

app/models/like.rb
class Like < ApplicationRecord
  belongs_to :user
  belongs_to :comment
end

app/models/post.rb
class Post < ApplicationRecord
  has_attached_file :image, styles: { large: "900x900>", medium: "500x500>", thumb: "100x100>" }
  validates_attachment_content_type :image, content_type: /\Aimage\/.*\z/


  has_many :comments, dependent: :destroy

  has_many :ratings, dependent: :destroy
  has_and_belongs_to_many :tags

  belongs_to :user

  has_one :post_option

  validates :title, presence: {message: "Missing title"}
  validates :perex, presence: {message: "Missing perex"}
  validates :text, presence: {message: "Missing text"}

  before_save :generate_timestamp
  before_create :build_associations

  def generate_timestamp
    self.added = DateTime.now
  end

  def assign_params_from_controller(params)
    @option_params = params
  end

  def build_associations
    #PostOption.new(@option_params).save
    self.post_option = PostOption.new(@option_params)
  end

  def primary_comments
    self.comments.where(parent_id: nil, approved: true).order(created_at: :desc)
  end

  def not_allowed_comments_for_current_user id
    self.comments.where(user_id: id, approved: false).order(created_at: :desc)
  end

  def not_allowed_comments
    self.comments.where(approved: false).order(created_at: :desc)
  end

end

app/models/post_option.rb
class PostOption < ApplicationRecord
end

app/models/rating.rb
class Rating < ApplicationRecord
  belongs_to :user
  belongs_to :post
  validates :value, numericality: { only_integer: true }, inclusion: { :in => [ 1, 2, 3, 4, 5 ] }
end

app/models/tag.rb
class Tag < ApplicationRecord
  has_and_belongs_to_many :posts
  validates :name, presence: {message: "Missing name of tag"}

end

app/models/under_comment.rb
class UnderComment < ApplicationRecord
  belongs_to :comment, dependent: :destroy
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable, :confirmable
  has_many :posts
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  def index
    @comments = Comment.all
  end

  def show
    @comment = Comment.find(params[:id])
  end

  def new
    @comment = Comment.new(parent_id: params[:parent_id])
  end

  def edit
    @comment = Comment.find(params[:id])
  end

  def create
    @comment = Comment.new(comment_params)

    @comment.approved = !PostOption.where(post_id: params[:post_id]).take.comment_needs_approval

    if @comment.save
      redirect_to post_path(Post.find(params[:post_id]))
    else
      #redirect back
      redirect_back fallback_location: root_path

      #show error message
      @comment.errors.messages.each do |msg|
        flash[:warning] = msg.second
      end

    end
  end

  def reply


    if params[:comment][:parent_id].to_i > 0

      # metoda comment_params nepovoluje parent_id, pretoze ked vytvaram comment bez parenta, nechcem tam mat tu polozku
      # preto treba delete(:parent_id)
      parent_comment = Comment.find_by_id(params[:comment].delete(:parent_id))

      # vytvorenie noveho commentu
      @comment = Comment.new(comment_params)

      #add_child vytvori vazby v stromovej strukture (ancestor, descendant, generation)
      parent_comment.add_child(@comment)


      @comment.save

      redirect_to post_path(Post.find(parent_comment.post_id))
    end
  end

  def update
    @comment = Comment.find(params[:id])

    if @comment.update(comment_params)
      redirect_to @comment
    else
      render 'edit'
    end
  end

  def destroy
    @post = Post.find(params[:post_id])
    @comment = @post.comments.find(params[:id])
    @comment.destroy
    redirect_to post_path(@post)
  end

  def approve
    @comment = Comment.find(params[:id])
    @comment.approved = true
    @comment.save

    redirect_back fallback_location: root_path


  end

  private
  def comment_params
    params.require(:comment).permit(:title, :content, :added, :likes, :dislikes, :approved, :user_id, :post_id)
  end

end

app/controllers/likes_controller.rb
class LikesController < ApplicationController

  def new
    @like = Like.new(like_params)
  end

  def create

    @post = Post.find(params[:post_id])

    #destroy dislike if exists
    @dislikes = Dislike.where(user_id: params[:user_id],comment_id: params[:comment_id])
    unless @dislikes.empty?
      @dislikes.first.destroy
    end

    @like = Like.new(like_params)
    @comment = Comment.find(params[:comment_id])
    @like.save

    respond_to do |format|
      format.js
    end
  end

  def destroy

    @post = Post.find(params[:post_id])
    @like = Like.where(user_id: params[:user_id],comment_id: params[:comment_id]).take
    @like.destroy

    respond_to do |format|
      format.js
    end

  end

  private
  def like_params
    params.permit(:user_id, :comment_id)
  end

end

app/controllers/tags_controller.rb
class TagsController < ApplicationController
  before_action :authenticate_user!

  def index
      @tags = Tag.all

  end

  ### show detail of tag
  def show
      @tag = Tag.find(params[:id])
  end

  ### new tag
  def new
    if current_user.admin?
      @tag = Tag.new
    else
       redirect_to root_path
    end
  end

  ### edit tag
  def edit
    if current_user.admin?
      @tag = Tag.find(params[:id])
    else
       redirect_to root_path
    end
  end

  ### create new tag
  def create
    if current_user.admin?
      @tag = Tag.new(tag_params)

      if @tag.save
        redirect_to @tag
      else
        #redirect back
        redirect_back fallback_location: root_path

        #show error message
        @tag.errors.messages.each do |msg|
          flash[:warning] = msg.second
        end
      end
    else
       redirect_to root_path
    end
  end

  ### update tag
  def update
    if current_user.admin?
      @tag = Tag.find(params[:id])

      if @tag.update(tag_params)
        redirect_to @tag
      else
        render 'edit'
      end
    else
       redirect_to root_path
    end
  end

  ### destroy chosen tag
  def destroy
    if current_user.admin?
      @tag = Tag.find(params[:id])
      @tag.destroy

      redirect_to tags_path
    else
       redirect_to root_path
    end
  end

  ### tag parameters
  private
  def tag_params
    params.require(:tag).permit(:name)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/dislikes_helper.rb
module DislikesHelper
end

app/helpers/likes_helper.rb
module LikesHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/helpers/ratings_helper.rb
module RatingsHelper
end

app/helpers/tag_posts_helper.rb
module TagPostsHelper
end

app/helpers/tags_helper.rb
module TagsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/comments/_basic_comment.html.erb
<p id="comment_<% comment.id %>">
<strong><%= comment.title %></strong>
  |
  <% if !comment.user_id.nil? and !User.find(comment.user_id).nil? %>
    <%= User.find(comment.user_id).name  %>
  <% else %>
    Anonymous user
  <% end  %>
  |
  <%= comment.created_at %>
  |
  <% if comment.can_like(current_user.id) %>
    <%= link_to likes_create_path(:comment_id => comment.id, :user_id => current_user.id, :post_id => comment.post_id), method: :post, :remote => true do %>
      <span class="glyphicon glyphicon-thumbs-up"></span>
    <% end %>
    <% else %>

    <%= link_to likes_destroy_path(:comment_id => comment.id, :user_id => current_user.id, :post_id => comment.post_id), method: :post, :remote => true do %>
      <span class="glyphicon glyphicon-thumbs-up like-active"></span>
    <% end %>


<% end %>


  <span id="like_div_<% comment.id %>">
    <%= comment.likes_count %>
  </span>
  |
  <% if comment.can_dislike(current_user.id) %>
    <%= link_to dislikes_create_path(:comment_id => comment.id, :user_id => current_user.id, :post_id => comment.post_id), method: :post, :remote => true do %>
      <span class="glyphicon glyphicon-thumbs-down"></span>
    <% end %>
  <% else %>
    <%= link_to dislikes_destroy_path(:comment_id => comment.id, :user_id => current_user.id, :post_id => comment.post_id), method: :post, :remote => true do %>
      <span class="glyphicon glyphicon-thumbs-down dislike-active"></span>
    <% end %>
  <% end %>

  <span id="dislike_div_<% comment.id %>">
  <%= comment.dislikes_count %>
  </span>

  <% if comment.user_id == current_user.id or @post.user_id == current_user.id%> |
    <%= link_to 'Delete comment', [comment.post, comment],
                method: :delete,
                data: { confirm: 'Are you sure?' } %>
  <% end  %>
</p>

<p>
  <%= comment.content %>
</p>

app/views/comments/_comment.html.erb
<%= render "comments/basic_comment", :comment => comment %>

<div>
  <button type="button" class="btn btn-edit" data-toggle="collapse" data-target="#reply_<%= comment.id %>" aria-controls="reply_<%= comment.id %>">
    <span class="glyphicon glyphicon-share-alt"></span>Reply</button>
  <div id="reply_<%= comment.id %>" class="collapse multi-collapse">
    <%= render "comments/reply", :locals => {parent_comment_id: comment.id} %>
  </div>
</div>

<% unless comment.children.empty? %>
  <div>
  <button type="button" class="btn btn-edit" data-toggle="collapse" data-target="#replies_<%= comment.id %>" aria-controls="replies_<%= comment.id %>" aria-expanded="true" >Show replies
  <span class="glyphicon glyphicon-menu-down"></span></button>
  <div id="replies_<%= comment.id %>" style="margin-left: 50px" class="collapse multi-collapse">
    <% comment.children.each do |reply| %>
      <%= render "comments/basic_comment", :comment => reply %>
      <br>
    <% end %>
  </div>
  </div>
<% end %>

<p class="line-break"></p>

app/views/comments/_form.html.erb
<%= form_with(model: [ @post, @post.comments.build ], local: true) do |form| %>
  <%= form.hidden_field :post_id, :value => @post.id%>
  <%= form.hidden_field :user_id, :value => current_user.id%>

  <p>
    Comment as <b><%= current_user.name %></b>
  </p>
  <div class="form-group">
    <%= form.label :title %><br>
    <%= form.text_field :title, :class=> "form-control" %>
  </div>
  <div class="form-group">
    <%= form.label :content %><br>
    <%= form.text_area :content, :class=> "form-control" %>
  </div>
  <p>
    <%= form.submit %>
  </p>
<% end %>

app/views/comments/_reply.html.erb
<%= form_with(model: [ @post, @post.comments.build ], local: true, :url => comments_reply_path, )  do |form| %>

  <%= form.hidden_field :parent_id, :value => locals[:parent_comment_id]%>
  <%= form.hidden_field :post_id, :value => @post.id%>
  <%= form.hidden_field :user_id, :value => current_user.id%>

  <p>
    <%= form.label :commenter %><br>
    Comment as <%= current_user.name %>
  </p>
  <div class="form-group">
    <%= form.label :title %><br>
    <%= form.text_field :title, :class=> "form-control" %>
  </div>
  <div class="form-group">
    <%= form.label :content %><br>
    <%= form.text_area :content, :class=> "form-control" %>
  </div>
  <p>
    <%= form.submit %>
  </p>
<% end %>

app/views/comments/_unpermitted_comment.html.erb
<p id="comment_<% comment.id %>">
  <strong><%= comment.title %></strong>
  |
  <% if !comment.user_id.nil? and !User.find(comment.user_id).nil? %>
    <%= User.find(comment.user_id).name  %>
  <% else %>
    Anonymous user
  <% end  %>
  |
  <%= comment.created_at %>
  |
  <% if comment.user_id == current_user.id or @post.user_id == current_user.id%> |
    <%= link_to 'Delete comment', [comment.post, comment],
                method: :delete,
                data: { confirm: 'Are you sure?' } %>
  <% end  %>
</p>

<p>
  <%= comment.content %>
</p>

<%if @post.user_id == current_user.id%>
 <%= button_to "Allow", {:controller => "comments", action: "approve", id: comment.id }, method: :post %>
<% end  %>